Index: main/waeup.futminna/trunk/src/waeup/futminna/students/batching.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/batching.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/batching.py	(revision 8619)
@@ -24,5 +24,5 @@
 students, studycourses, payment tickets and accommodation tickets.
 """
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.interfaces import (
     ICustomStudent, ICustomStudentUpdateByRegNo,
     ICustomStudentUpdateByMatricNo
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/browser.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/browser.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/browser.py	(revision 8619)
@@ -33,10 +33,10 @@
 from waeup.kofa.students.viewlets import (
     PaymentReceiptActionButton)
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.interfaces import (
     ICustomStudentBase, ICustomStudent, ICustomStudentPersonal,
     ICustomUGStudentClearance,ICustomPGStudentClearance,
     ICustomStudentOnlinePayment,
     )
-from waeup.uniben.interfaces import MessageFactory as _
+from waeup.futminna.interfaces import MessageFactory as _
 
 #class RequestCallbackActionButton(RequestCallbackActionButton):
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/interfaces.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/interfaces.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/interfaces.py	(revision 8619)
@@ -29,9 +29,9 @@
 from waeup.kofa.students.vocabularies import (
     nats_vocab, contextual_reg_num_source)
-from waeup.uniben.interfaces import (
+from waeup.futminna.interfaces import (
     high_qual, high_grade, exam_types, LGASource)
-from waeup.uniben.interfaces import MessageFactory as _
-from waeup.uniben.payments.interfaces import ICustomOnlinePayment
-from waeup.uniben.utils.lgas import LGAS
+from waeup.futminna.interfaces import MessageFactory as _
+from waeup.futminna.payments.interfaces import ICustomOnlinePayment
+from waeup.futminna.utils.lgas import LGAS
 
 
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/payments.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/payments.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/payments.py	(revision 8619)
@@ -25,5 +25,5 @@
 from waeup.kofa.students.payments import StudentOnlinePayment
 from waeup.kofa.utils.helpers import attrs_to_fields
-from waeup.uniben.students.interfaces import ICustomStudentOnlinePayment
+from waeup.futminna.students.interfaces import ICustomStudentOnlinePayment
 
 class CustomStudentOnlinePayment(StudentOnlinePayment):
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/student.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/student.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/student.py	(revision 8619)
@@ -23,5 +23,5 @@
 from waeup.kofa.utils.helpers import attrs_to_fields
 from waeup.kofa.students.student import Student, StudentFactory
-from waeup.uniben.students.interfaces import ICustomStudent, IStudentNavigation
+from waeup.futminna.students.interfaces import ICustomStudent, IStudentNavigation
 
 
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/studycourse.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/studycourse.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/studycourse.py	(revision 8619)
@@ -26,5 +26,5 @@
 from waeup.kofa.utils.helpers import attrs_to_fields
 from waeup.kofa.students.workflow import CLEARED, RETURNING, PAID
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.interfaces import (
     ICustomStudentStudyCourse, IStudentNavigation)
 
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/studylevel.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/studylevel.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/studylevel.py	(revision 8619)
@@ -27,5 +27,5 @@
     StudentStudyLevel, CourseTicket,
     CourseTicketFactory, StudentStudyLevelFactory)
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.interfaces import (
     ICustomStudentStudyLevel, IStudentNavigation, ICustomCourseTicket)
 
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/tests/test_browser.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/tests/test_browser.py	(revision 8619)
@@ -28,7 +28,7 @@
 from waeup.kofa.students.batching import StudentProcessor
 from waeup.kofa.students.interfaces import IStudentsUtils
-from waeup.uniben.students.batching import CustomStudentProcessor
-from waeup.uniben.testing import FunctionalLayer
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.batching import CustomStudentProcessor
+from waeup.futminna.testing import FunctionalLayer
+from waeup.futminna.students.interfaces import (
     ICustomStudentStudyCourse, ICustomStudent,
     ICustomStudentStudyLevel, ICustomCourseTicket)
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/tests/test_student.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/tests/test_student.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/tests/test_student.py	(revision 8619)
@@ -22,15 +22,15 @@
 from zope.interface import verify
 from waeup.kofa.testing import FunctionalTestCase
-from waeup.uniben.students.student import CustomStudent, CustomStudentFactory
-from waeup.uniben.students.studycourse import (
+from waeup.futminna.students.student import CustomStudent, CustomStudentFactory
+from waeup.futminna.students.studycourse import (
     CustomStudentStudyCourse, CustomStudentStudyCourseFactory)
-from waeup.uniben.students.studylevel import (
+from waeup.futminna.students.studylevel import (
     CustomStudentStudyLevel, CustomCourseTicket,
     CustomStudentStudyLevelFactory,
     CustomCourseTicketFactory)
-from waeup.uniben.students.interfaces import (
+from waeup.futminna.students.interfaces import (
     ICustomStudent, ICustomStudentStudyCourse,
     ICustomStudentStudyLevel, ICustomCourseTicket)
-from waeup.uniben.testing import FunctionalLayer
+from waeup.futminna.testing import FunctionalLayer
 
 
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/utils.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/utils.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/utils.py	(revision 8619)
@@ -23,5 +23,5 @@
 from waeup.kofa.students.interfaces import IStudentsUtils
 from waeup.kofa.accesscodes import create_accesscode
-from waeup.uniben.interfaces import MessageFactory as _
+from waeup.futminna.interfaces import MessageFactory as _
 
 class CustomStudentsUtils(StudentsUtils):
@@ -154,5 +154,5 @@
         }
 
-    # Uniben separators
+    # FUTMinna separators
     SEPARATORS_DICT = {
         'form.fst_sit_fname': _(u'First Sitting Record'),
@@ -163,7 +163,7 @@
         'form.nysc_year': _(u'NYSC Information'),
         'form.employer': _(u'Employment History'),
-        'form.former_matric': _(u'Former Uniben Student'),
+        'form.former_matric': _(u'Former FUTMinna Student'),
         }
 
-    # Uniben prefix
-    STUDENT_ID_PREFIX = u'B'
+    # FUTMinna prefix
+    STUDENT_ID_PREFIX = u'M'
Index: main/waeup.futminna/trunk/src/waeup/futminna/students/viewlets.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/uniben/students/viewlets.py	(revision 8618)
+++ main/waeup.futminna/trunk/src/waeup/futminna/students/viewlets.py	(revision 8619)
@@ -22,5 +22,5 @@
 from waeup.kofa.students.browser import ExportPDFClearanceSlipPage
 
-from waeup.uniben.interfaces import MessageFactory as _
+from waeup.futminna.interfaces import MessageFactory as _
 
 # LGA Identification