Index: main/waeup.futminna/trunk/README-zeo.txt
===================================================================
--- main/waeup.futminna/trunk/README-zeo.txt	(revision 8619)
+++ main/waeup.futminna/trunk/README-zeo.txt	(revision 8620)
@@ -1,3 +1,3 @@
-Deploying waeup.uniben as ZEO-install
+Deploying waeup.futminna as ZEO-install
 *************************************
 
@@ -14,5 +14,5 @@
 ========================
 
-To install waeup.uniben ZEO-based you can run `buildout` with the given
+To install waeup.futminna ZEO-based you can run `buildout` with the given
 (or your own) configuration file like this::
 
Index: main/waeup.futminna/trunk/buildout-windows.cfg
===================================================================
--- main/waeup.futminna/trunk/buildout-windows.cfg	(revision 8619)
+++ main/waeup.futminna/trunk/buildout-windows.cfg	(revision 8620)
@@ -25,5 +25,5 @@
 # This creates only the paster script in bin/.
 recipe = zc.recipe.egg
-eggs = waeup.uniben
+eggs = waeup.futminna
        z3c.evalexception>=2.0
        Paste
Index: main/waeup.futminna/trunk/buildout-zeo.cfg
===================================================================
--- main/waeup.futminna/trunk/buildout-zeo.cfg	(revision 8619)
+++ main/waeup.futminna/trunk/buildout-zeo.cfg	(revision 8620)
@@ -112,5 +112,5 @@
 # See http://pypi.python.org/pypi/zc.recipe.egg for details...
 recipe = zc.recipe.egg
-eggs = waeup.uniben [beaker]
+eggs = waeup.futminna [beaker]
 arguments = "${buildout:parts-directory}/etc/zeo1.conf"
 scripts = kofactl=zeo_client1
@@ -119,5 +119,5 @@
 # See http://pypi.python.org/pypi/zc.recipe.egg for details...
 recipe = zc.recipe.egg
-eggs = waeup.uniben [beaker]
+eggs = waeup.futminna [beaker]
 arguments = "${buildout:parts-directory}/etc/zeo2.conf"
 scripts = kofactl=zeo_client2
Index: main/waeup.futminna/trunk/buildout.cfg
===================================================================
--- main/waeup.futminna/trunk/buildout.cfg	(revision 8619)
+++ main/waeup.futminna/trunk/buildout.cfg	(revision 8620)
@@ -34,5 +34,5 @@
 # This creates all scripts in bin/. The kofactl created here is 'faulty'.
 recipe = zc.recipe.egg
-eggs = waeup.uniben [beaker]
+eggs = waeup.futminna [beaker]
        z3c.evalexception>=2.0
        Paste
@@ -47,5 +47,5 @@
 # fixed path to zdaemon.conf as argument.
 recipe = zc.recipe.egg
-eggs = waeup.uniben [beaker]
+eggs = waeup.futminna [beaker]
 arguments = "${buildout:parts-directory}/etc/zdaemon.conf"
 scripts = kofactl=kofactl
@@ -62,5 +62,5 @@
 [test]
 recipe = zc.recipe.testrunner
-eggs = waeup.uniben [beaker, test]
+eggs = waeup.futminna [beaker, test]
 defaults = ['--tests-pattern', '^f?tests$', '-v']
 
@@ -68,8 +68,8 @@
 [i18n]
 recipe = z3c.recipe.i18n:i18n
-packages = waeup.uniben
-eggs = waeup.uniben
-domain = waeup.uniben
-output = src/waeup/uniben/locales
+packages = waeup.futminna
+eggs = waeup.futminna
+domain = waeup.futminna
+output = src/waeup/futminna/locales
 zcml =
 
@@ -78,5 +78,5 @@
 [zpasswd]
 recipe = z3c.recipe.dev:script
-eggs = waeup.uniben
+eggs = waeup.futminna
 module = zope.app.server.zpasswd
 method = main
@@ -135,5 +135,5 @@
 [waeupdocs]
 recipe = collective.recipe.sphinxbuilder
-eggs = waeup.uniben[docs]
+eggs = waeup.futminna[docs]
 source = ${buildout:directory}/docs/source
 build = ${buildout:directory}/docs/build
@@ -142,5 +142,5 @@
 [coverage-detect]
 recipe = zc.recipe.testrunner
-eggs = waeup.uniben[beaker]
+eggs = waeup.futminna[beaker]
 defaults = ['--tests-pattern', '^f?tests$', '-v', '--coverage', 'coverage']
 
Index: main/waeup.futminna/trunk/etc/debug.ini.in
===================================================================
--- main/waeup.futminna/trunk/etc/debug.ini.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/debug.ini.in	(revision 8620)
@@ -54,5 +54,5 @@
 
 [app:zope]
-use = egg:waeup.uniben#debug
+use = egg:waeup.futminna#debug
 filter-with = translogger
 exempt-exceptions = zope.security.interfaces.IUnauthorized
Index: main/waeup.futminna/trunk/etc/deploy.ini.in
===================================================================
--- main/waeup.futminna/trunk/etc/deploy.ini.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/deploy.ini.in	(revision 8620)
@@ -48,5 +48,5 @@
 
 [app:main]
-use = egg:waeup.uniben
+use = egg:waeup.futminna
 filter-with = translogger
 
@@ -54,5 +54,5 @@
 use = egg:Paste#http
 host = 0.0.0.0
-port = 7011
+port = 7041
 
 [DEFAULT]
Index: main/waeup.futminna/trunk/etc/profile.ini.in
===================================================================
--- main/waeup.futminna/trunk/etc/profile.ini.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/profile.ini.in	(revision 8620)
@@ -52,5 +52,5 @@
 
 [app:app]
-use = egg:waeup.uniben
+use = egg:waeup.futminna
 
 [pipeline:main]
Index: main/waeup.futminna/trunk/etc/site.zcml.in
===================================================================
--- main/waeup.futminna/trunk/etc/site.zcml.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/site.zcml.in	(revision 8620)
@@ -1,8 +1,8 @@
 <configure xmlns="http://namespaces.zope.org/zope"
            xmlns:kofa="http://namespaces.waeup.org/kofa"
-           i18n_domain="waeup.uniben">
+           i18n_domain="waeup.futminna">
 
-  <include package="waeup.uniben" />
-  <include package="waeup.uniben" file="mail.zcml" />
+  <include package="waeup.futminna" />
+  <include package="waeup.futminna" file="mail.zcml" />
 
   <!-- Where should the datacenter reside by default? -->
@@ -10,5 +10,5 @@
       path="${buildout:directory}/var/datacenter" />
 
-    <configure i18n_domain="waeup.uniben">
+    <configure i18n_domain="waeup.futminna">
 
       <unauthenticatedPrincipal id="zope.anybody"
Index: main/waeup.futminna/trunk/etc/zdaemon.conf.in
===================================================================
--- main/waeup.futminna/trunk/etc/zdaemon.conf.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/zdaemon.conf.in	(revision 8620)
@@ -5,4 +5,4 @@
   socket-name ${zope_conf:logfiles}/zdaemonsock
   # Enable this to run the child process as a different user
-  # user zope
+  user kofa
 </runner>
Index: main/waeup.futminna/trunk/etc/zeo1.ini.in
===================================================================
--- main/waeup.futminna/trunk/etc/zeo1.ini.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/zeo1.ini.in	(revision 8620)
@@ -48,5 +48,5 @@
 
 [app:main]
-use = egg:waeup.uniben
+use = egg:waeup.futminna
 filter-with = translogger
 
@@ -54,5 +54,5 @@
 use = egg:Paste#http
 host = 0.0.0.0
-port = 7011
+port = 7041
 threadpool_workers = 50
 use_threadpool = True
Index: main/waeup.futminna/trunk/etc/zeo2.ini.in
===================================================================
--- main/waeup.futminna/trunk/etc/zeo2.ini.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/zeo2.ini.in	(revision 8620)
@@ -48,5 +48,5 @@
 
 [app:main]
-use = egg:waeup.uniben
+use = egg:waeup.futminna
 filter-with = translogger
 
@@ -54,5 +54,5 @@
 use = egg:Paste#http
 host = 0.0.0.0
-port = 7012
+port = 7042
 threadpool_workers = 50
 use_threadpool = True
Index: main/waeup.futminna/trunk/etc/zope_zeo1.conf.in
===================================================================
--- main/waeup.futminna/trunk/etc/zope_zeo1.conf.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/zope_zeo1.conf.in	(revision 8620)
@@ -24,5 +24,5 @@
 # Uncomment this if you want to connect to a ZEO server instead:
   <zeoclient>
-    server localhost:7010
+    server localhost:7040
     storage 1
     # ZEO client cache, in bytes
Index: main/waeup.futminna/trunk/etc/zope_zeo2.conf.in
===================================================================
--- main/waeup.futminna/trunk/etc/zope_zeo2.conf.in	(revision 8619)
+++ main/waeup.futminna/trunk/etc/zope_zeo2.conf.in	(revision 8620)
@@ -24,5 +24,5 @@
 # Uncomment this if you want to connect to a ZEO server instead:
   <zeoclient>
-    server localhost:7010
+    server localhost:7040
     storage 1
     # ZEO client cache, in bytes
Index: main/waeup.futminna/trunk/setup.py
===================================================================
--- main/waeup.futminna/trunk/setup.py	(revision 8619)
+++ main/waeup.futminna/trunk/setup.py	(revision 8620)
@@ -43,5 +43,5 @@
     read('README.txt')
     + '\n\n'
-    + read('src', 'waeup', 'uniben', 'README.txt')
+    + read('src', 'waeup', 'futminna', 'README.txt')
     + '\n\n'
     + read('CHANGES.txt')
@@ -51,5 +51,5 @@
     )
 
-setup(name = 'waeup.uniben',
+setup(name = 'waeup.futminna',
       version = version,
       description = "A customized waeup.kofa",
@@ -89,5 +89,5 @@
       # Add entry points here
       [hurry.resource.libraries]
-      waeup_custom = waeup.uniben.browser.resources:waeup_custom
+      waeup_custom = waeup.futminna.browser.resources:waeup_custom
       [console_scripts]
       kofa-debug = grokcore.startup:interactive_debug_prompt