Index: main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 8621)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 8626)
@@ -442,4 +442,15 @@
         return studycourse.get(row['level'])
 
+    def updateEntry(self, obj, row, site):
+        """Update obj to the values given in row.
+        """
+        items_changed = super(StudentStudyLevelProcessor, self).updateEntry(
+            obj, row, site)
+        student = self.getParent(row, site).__parent__
+        student.__parent__.logger.info(
+            '%s - Study level updated: %s'
+            % (student.student_id, items_changed))
+        return
+
     def addEntry(self, obj, row, site):
         parent = self.getParent(row, site)
@@ -492,4 +503,15 @@
             return None
         return level.get(row['code'])
+
+    def updateEntry(self, obj, row, site):
+        """Update obj to the values given in row.
+        """
+        items_changed = super(CourseTicketProcessor, self).updateEntry(
+            obj, row, site)
+        student = self.getParent(row, site).__parent__.__parent__
+        student.__parent__.logger.info(
+            '%s - Course ticket updated: %s'
+            % (student.student_id, items_changed))
+        return
 
     def addEntry(self, obj, row, site):
@@ -561,4 +583,15 @@
             entry = payments.get('p' + p_id[6:])
         return entry
+
+    def updateEntry(self, obj, row, site):
+        """Update obj to the values given in row.
+        """
+        items_changed = super(StudentOnlinePaymentProcessor, self).updateEntry(
+            obj, row, site)
+        student = self.getParent(row, site).__parent__
+        student.__parent__.logger.info(
+            '%s - Payment ticket updated: %s'
+            % (student.student_id, items_changed))
+        return
 
     def addEntry(self, obj, row, site):
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 8621)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 8626)
@@ -150,4 +150,7 @@
         self.app['faculties']['fac1']['dep1'].certificates.addCertificate(
             self.certificate)
+
+        self.logfile = os.path.join(
+            self.app['datacenter'].storage, 'logs', 'students.log')
         return
 
@@ -647,4 +650,11 @@
         shutil.rmtree(os.path.dirname(fin_file))
 
+        logcontent = open(self.logfile).read()
+        # Logging message from updateEntry,
+        self.assertTrue(
+            'INFO - system - K1000000 - Study level '
+            'updated: level=100, level_verdict=C, level_session=2009'
+            in logcontent)
+
     def test_import_update(self):
         # We perform the same import twice,
@@ -741,4 +751,11 @@
         self.assertEqual(courseticket.semester, 1)
         shutil.rmtree(os.path.dirname(fin_file))
+
+        logcontent = open(self.logfile).read()
+        # Logging message from updateEntry,
+        self.assertTrue(
+            'INFO - system - K1000000 - Course ticket updated: code=COURSE1, '
+            'mandatory=False, score=3'
+            in logcontent)
 
     def test_import_update(self):
@@ -844,4 +861,14 @@
         shutil.rmtree(os.path.dirname(fin_file))
 
+        logcontent = open(self.logfile).read()
+        # Logging message from updateEntry,
+        self.assertTrue(
+            'INFO - system - K1000001 - Payment ticket updated: '
+            'p_id=p1266236341955, p_item=BTECHBDT, '
+            'creation_date=2010-02-15 13:19:01+00:00, r_code=00, '
+            'r_amount_approved=19500.0, p_category=schoolfee, '
+            'amount_auth=19500.0, p_state=paid'
+            in logcontent)
+
     def test_import_update(self):
         # We perform the same import twice,